#! /usr/bin/env node

console.log('anyserver')

// 没有参数  端口默认8000

// 有参数的时候  端口是传的参数
// -v
// -p  9091
// -s


// 服务启动成功之后
// 1. 自动打开浏览器  2.读取文件夹下所有的信息  
// 3. 点击的是文件的时候展示文件内容，点击是文件夹的时候，展示文件夹里面的信息



// 命令行工具的功能写完了之后，就可以发包
// console.log(process.argv)
const args = process.argv.slice(2);
let PORT = 8000;
const http = require('http');
const path = require('path');
const {existsSync,statSync,readdirSync,readFileSync} = require('fs');
const {networkInterfaces} = require('os');
const {exec} = require('child_process');
// console.log(args)

function createserver(){
    http.createServer((req,res)=>{
        // console.log(req.url,'&&&&&&&&&')
        // console.log(__dirname,'&&&&&&&&&')
        let rootpath = process.cwd();
        // C:\teaching\1809A\node1809a\day3anyserever
        // localhost:8000/bin
        // console.log(rootpath,'&&&&&&&&&')
        rootpath = path.join(rootpath,req.url)
        // console.log(rootpath,'rootpath')
        if(existsSync(rootpath)){
            //路径是否存在
            if(statSync(rootpath).isDirectory()){
                //是否是文件夹
                let html = readFileSync(path.join(__dirname,'../public/index.html'),'utf-8')
                let dirarr = readdirSync(rootpath)
                // [ 'bin', 'package-lock.json', 'package.json', 'public' ]
                // console.log(html)
                let lihtml = dirarr.map(item =>{
                    return `<li>
                        <a href='${path.join(req.url,item)}'>${item}</a>
                    </li>`
                }).join('')
                html = html.replace('{{list}}',lihtml)
                res.end(html);
            } else {
                //文件 度当前路径的文件，展示到页面
                // console.log('else')
                res.end(readFileSync(rootpath),'utf-8');
            }
        } else{
            // console.log('路径不存在')
            res.end('路径不存在');
        }
    }).listen(PORT,()=>{
        console.log('服务启动成功');
        // 服务启动成功之后自动打开
        console.log(networkInterfaces().WLAN)
        const hostname = networkInterfaces().WLAN.find(item => item.family == 'IPv4').address;
        console.log(hostname)
        // http://192.168.0.105:8000
        const address = `http://${hostname}:${PORT}`;
        console.log(address)
        // 自动打开,开启一个子进程
        exec(`start ${address}`);
    })
}

if(args.length == 0){
    //没有参数
    console.log('端口号默认8000')
    createserver();
} else {
    //有参数
    if(args[0] == '-v'){
        console.log('版本号是1.0.0')
    } else if(args[0] == '-p'){ // -p 9091
        console.log('端口号'+args[1])
        PORT = args[1];
        createserver()
    }
}